#/usr/bin/perl

use strict;
use DBI;

&main(@ARGV);

1;

sub main {
    my (@ARGV) = @_;
    
    my ($site, $dbh, $objid, $object_hashref, $key, $where_clause);
    my ($fields, @definitions, $sql, $all_sql, $h, $key, $q, @objids);
    my ($where_clause, $object_hashref, $res, $i, %FORM, @master , $obj_inf);

    ($site, $dbh) = &initscript();

    $dbh = DBI->connect($site->{'db_site_connect'}, "$site->{'site_dbiuser'}", "$site->{'site_dbipwd'}");

    my (@variants, @variant_sets);

    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
#    $FORM{'search_objtype'} = "45000-A";
    $FORM{'search_status'} = "15000-A";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }

    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
#    $FORM{'search_objtype'} = "45000-A";
    $FORM{'search_status'} = "15000-A";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }

    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
    $FORM{'search_objtype'} = "181-A";
    $FORM{'search_status'} = "15000-A";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }

    # Get contact row
    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "admin";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }

    # Get keywords
    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "two";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }

    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "French";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }



    # Get Variants
    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "blue";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }


    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "blue";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }



    # Get Variants
    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "bleu";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }


    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "bleu";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }



    # Get Variants
    $site->{'om_render_lang'} = "eng";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "blue";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }


    $site->{'om_render_lang'} = "fra";
    $FORM{'mode'} = "search";
    $FORM{'search_status'} = "15000-A";
    $FORM{'search_keywords'} = "bleu";
    $FORM{'startrow'} = "now";
    $FORM{'lang_startrow'} = 0;
    while ($FORM{'startrow'} ne "") {
	if ($FORM{'startrow'} eq "now") {
	    $FORM{'startrow'} = "";
	}
	&do_admin_object_search(\%FORM, $site, $dbh);
    }


    $dbh->disconnect();
}

sub display_search_results {
    my ($link) = shift;
    my ($previous) = shift;
    my ($startrow) = shift;
    my ($site) = shift;
    my ($FORM) = shift;
    my ($results) = shift;

    my $res;

    foreach $res (@$results) {
	if (defined $res->{'title'}) {
	    print "Got: $res->{'title'}\n";
	}
	if (defined $res->{'uname'}) {
	    print "Got: $res->{'uname'}\n";
	}

    }





}
######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - ($site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and connect to the database

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my ($k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";

    ## short circuit if $s does not contain tests
    if ( $s !~ /tests/ ) {
	$siteshortname = pop @rpath;
	$relpath=".";
	@temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
	if ( $u eq "tests" ) {
	    $siteshortname = $temp[$#temp];
	    @temp=();
	} # note - tests is off the site root, so the next up is site root        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh) = &initsite($scriptname, $relpath);
    $site->{'siteshortname'} = $siteshortname;
    
    return ($site, $dbh);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (inventory.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $site, $dbh);
    my ($select_hash, $q2, $html_def);

    use DBI;
    require "$relpath/conf/site.pm";
    require "$relpath/conf/html_def.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/object_search.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/lib/permission_layer.pm";    
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/language.pm";
#    require "$relpath/lib/search.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/pages";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/test_admin";
    $site->{'sid'} = $site->{'sid'};
    $site->{'session_lang'} = $session_lang;
    $site->{'html_def'} = &set_html_def();
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'targetpath'}="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/transit/export/order";    
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    $site->{'languageSensitive'} = "title,brief,keywords,author,descript,encoding,uperms,uperm,gen_trigs";
    $site->{'inherit_from_master'} = "brief";
    $site->{'autosku'} = "yes";
    $site->{'override_permissions'} = "yes";
    $site->{'search_results_per_page'} = 10;

    &debug("Debuggin inventory.cgi...",3, $site->{'debug_level'}, ">/tmp/inventory");
    return ($site, $dbh);
}






