#/usr/bin/perl

use strict;
use DBI;

&main(@ARGV);

1;

sub main {
    my (@ARGV) = @_;
    
    my ($site, $dbh, $objid, $object_hashref, $key, $where_clause);
    my ($fields, @definitions, $sql, $all_sql, $h, $key, $q, @objids);
    my ($where_clause, $object_hashref, $res, $i, %FORM, @master );

    ($site, $dbh) = &initscript();

    $dbh = DBI->connect($site->{'db_site_connect'}, "$site->{'site_dbiuser'}", "$site->{'site_dbipwd'}");

    my (@variants, @variant_sets);
    $site->{'om_render_lang'} = "eng";
#    &test_contact($site, $dbh);

    $site->{'om_render_lang'} = "eng";
#    &test_product_line($site, $dbh);

    $site->{'om_render_lang'} = "eng";
#    &test_internal_doc($site, $dbh);

    $site->{'om_render_lang'} = "eng";
#    &test_article($site, $dbh);

    $site->{'om_render_lang'} = "eng";
#    &test_pulldown($site, $dbh);

    my (@brands);
    $site->{'om_render_lang'} = "eng";
#    &test_brand($site, $dbh, \@brands);

    $site->{'om_render_lang'} = "eng";
#    &test_product($site, $dbh, \@brands);

    $site->{'om_render_lang'} = "eng";
#    &test_warehouse($site, $dbh);

    $site->{'om_render_lang'} = "eng";
#    &test_variants($site, $dbh, \@variants);

    $site->{'om_render_lang'} = "eng";
#    &test_variant_set($site, $dbh, \@variants, \@variant_sets);

    $site->{'om_render_lang'} = "eng";
#    &test_master_product($site, $dbh, \@variant_sets, \@master, \@brands);

    $site->{'om_render_lang'} = "eng";
#    &test_variant_product($site, $dbh, $master[0], \@variants);

    $site->{'om_render_lang'} = "eng";
#    &test_modify_variant_titles($site, $dbh, $master[0], \@variants, \@variant_sets);

    &test_attribute($ARGV[0], $site, $dbh);

    $dbh->disconnect();
}

sub test_attribute {
    my ($objid) = shift;

    my ($site) = shift;
    my ($dbh) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);

    print "Testing ATtribute\n";

    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Product Line";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'html_inp'} = "Test new html";
    $FORM{'objclass_inp'} = "101-A";
    $FORM{'lang_sens_inp'} = "0";

    $FORM{'title_pre'} = "new_attribute";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'html_pre'} = "Test new html";
    $FORM{'lang_sens_pre'} = "0";

    $res = &update_object($objid, \%FORM, $site, $dbh);
    print $res;

}

sub test_contact {
    my ($site) = shift;
    my ($dbh) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    my ($objid);

    print "Testing Contact\n\n";

    %FORM = {};
    $FORM{'uname_inp'} = "tara";   
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'contact'};
    $FORM{'passwd_inp'} = "babyRob#1";
    $FORM{'hint_inp'} = "what's my mans name?";
#    $FORM{'uperms_inp'} = "";
#    $FORM{'uperm_inp'} = "";
    $FORM{'gen_trigs_inp'} = "yes";
    
    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objid = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;

    %FORM = {};
    $FORM{'uname_pre'} = "tara";   
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'contact'};
    $FORM{'passwd_pre'} = "babyRob#1";
    $FORM{'hint_pre'} = "what's my mans name?";
#    $FORM{'uperms_pre'} = "";
#    $FORM{'uperm_pre'} = "";
    $FORM{'gen_trigs_pre'} = "yes";


    $FORM{'uname_inp'} = "tarag";   
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'contact'};
    $FORM{'passwd_inp'} = "babyRob#1";
    $FORM{'hint_inp'} = "what's my mans name?";
#    $FORM{'uperms_inp'} = "";
#    $FORM{'uperm_inp'} = "";
    $FORM{'gen_trigs_inp'} = "no";

    $res = &update_object($objid,\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objid\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $FORM{'uname_pre'} = "tarag";   
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'contact'};
    $FORM{'passwd_pre'} = "babyRob#1";
    $FORM{'hint_pre'} = "what's my mans name?";
#    $FORM{'uperms_pre'} = "";
#    $FORM{'uperm_pre'} = "";
    $FORM{'gen_trigs_pre'} = "no";


    $FORM{'uname_inp'} = "tarag";   
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'contact'};
    $FORM{'passwd_inp'} = "babyRob#1";
    $FORM{'hint_inp'} = "what's my baby's name?";
#    $FORM{'uperms_inp'} = "";
#    $FORM{'uperm_inp'} = "";
    $FORM{'gen_trigs_inp'} = "yes";
    $res = &update_object($objid,\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objid";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objid,  "contacts", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}

sub test_product_line {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);

    print "Testing Product Line:\n\n";
    # Product line
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Product Line";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product_line'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product_line'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    # Product line
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Product Line";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product_line'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product_line'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Product Line";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Modified Description";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product_line'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product_line'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;
    # Product line
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Product Line";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product_line'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product_line'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Product Line FRA";
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product_line'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product_line'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}







sub test_internal_doc {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);

    print "Testing internal doc\n\n";
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Internal_Doc";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'internal_doc'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'internal_doc'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110001-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    # Product line
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Internal_Doc";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'internal_doc'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'internal_doc'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110001-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Internal Doc";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Modified Description";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'internal_doc'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'internal_doc'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110001-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Internal_Doc";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'internal_doc'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'internal_doc'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110001-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Internal doc FRA";
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'internal_doc'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'internal_doc'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110001-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}


sub test_article {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    # Product line
    print "Testing Article\n\n";
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Article";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'article'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'article'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    # Product line
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Article";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'article'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'article'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brief";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Modified Description";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'article'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'article'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Article";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'article'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'article'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brief FRA";
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'article'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'article'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}

sub test_pulldown {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    print "Testing Pulldown:\n\n";
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Pulldown";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'encoding_inp'} = "mon|Monday\r\ntue|Tuesday";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'pulldown'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'pulldown'};
    $FORM{'sel_name_inp'} = "sel_days";
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Pulldown";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'encoding_pre'} = "mon|Monday\r\ntue|Tuesday";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'pulldown'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'pulldown'};
    $FORM{'sel_name_pre'} = "sel_days";
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    

    $FORM{'title_inp'} = "Auto Generated Pulldown";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'encoding_inp'} = "mon|Monday\r\ntue|Tuesday\r\nwed|Wednesday\r\nthur|Thursday\r\nfri|Friday";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'pulldown'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'pulldown'};
    $FORM{'sel_name_inp'} = "sel_days";
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Pulldown";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'encoding_pre'} = "mon|Monday\r\ntue|Tuesday";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'pulldown'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'pulldown'};
    $FORM{'sel_name_pre'} = "sel_days";
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    

    $FORM{'title_inp'} = "Auto Generated Pulldown FRA";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'encoding_inp'} = "mon|luidai\r\n";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'pulldown'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'pulldown'};
    $FORM{'sel_name_inp'} = "sel_days";
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}





sub test_warehouse {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);

    %FORM = {};
    $FORM{'title_inp'} = "Auto ";
    $FORM{'brief_inp'} = "";
    $FORM{'keywords_inp'} = "";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'warehouse'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'warehouse'};
    $FORM{'status_inp'} = "15000-A";
    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;

    $FORM{'title_pre'} = "Auto ";
    $FORM{'brief_pre'} = "";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'warehouse'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'warehouse'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'keywords_pre'} = "";

    $FORM{'title_inp'} = "Auto Generated Warehouse";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'keywords_inp'} = "Warehouse Keys";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'warehouse'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'warehouse'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Warehouse";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'warehouse'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'warehouse'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'keywords_pre'} = "";

    $FORM{'title_inp'} = "Auto Generated Warehouse FRA";
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'keywords_inp'} = "Warehouse Keys";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'warehouse'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'warehouse'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}

sub test_brand {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($brand) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    # Product line
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Brand";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'sku_skel_inp'} = "abc";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'brand'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'brand'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$$brand[$i] = $FORM{'objid'};
	$objids[$i++] = $FORM{'objid'};

    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    # Product line
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Brand";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'sku_skel_pre'} = "abc";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'brand'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'brand'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brand";
    $FORM{'sku_skel_inp'} = "abc";
    $FORM{'brief_inp'} = "Brand Brief";
    $FORM{'descript_inp'} = "Brand Description";
    $FORM{'keywords_inp'} = "BRAND: These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'brand'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'brand'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }


    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Brand";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'sku_skel_pre'} = "abc";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'brand'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'brand'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brand FRA";
    $FORM{'sku_skel_inp'} = "abc";
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'brand'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'brand'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}


sub test_variant_set {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($variants) = shift;
    my ($variant_set) = shift;
    my ($set, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);

    my ($set);

    $set = join ":", @$variants;
    %FORM = {};
    $FORM{'title_inp'} = "Colord";
    $FORM{'brief_inp'} = "This is the description for color";
    $FORM{'variant_set_inp'} = $set;
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant_set'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant_set'};
    $FORM{'status_inp'} = "15000-A";
    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i] = $FORM{'objid'};
	$$variant_set[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Colord";
    $FORM{'brief_pre'} = "This is the description for color";
    $FORM{'variant_set_pre'} = $set;
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'variant_set'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'variant_set'};
    $FORM{'status_pre'} = "15000-A";

    $FORM{'title_inp'} = "Color";
    $FORM{'brief_inp'} = "MODIFIED This is the description for color";
    $FORM{'variant_set_inp'} = $set;
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant_set'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant_set'};
    $FORM{'status_inp'} = "15000-A";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $site->{'om_render_lang'} = "fra";
    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Color";
    $FORM{'brief_pre'} = "MODIFIED This is the description for color";
    $FORM{'variant_set_pre'} = $set;
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'variant_set'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'variant_set'};
    $FORM{'status_pre'} = "15000-A";

    $FORM{'title_inp'} = "Colour";
    $FORM{'brief_inp'} = "Francais COLOUR";
    $FORM{'variant_set_inp'} = $set;
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant_set'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant_set'};
    $FORM{'status_inp'} = "15000-A";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    foreach $obj (@objids) {
	$object_hashref = {};
	$object_hashref = &load_object($obj,  "", "", $where_clause, $site, $dbh, 1);
	&printHashref($object_hashref);
	print "\n____________________ NEXT _______________________\n";
    }
}



sub test_variants {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($variants) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    %FORM = {};
    $FORM{'title_inp'} = "Red";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_inp'} = "15000-A";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i] = $FORM{'objid'};
	$$variants[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    %FORM = {};
    $FORM{'title_inp'} = "Blue";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_inp'} = "15000-A";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i] = $FORM{'objid'};
	$$variants[$i++] = $FORM{'objid'};
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Red";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_pre'} = "15000-A";

    $FORM{'title_inp'} = "Green";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_inp'} = "15000-A";

    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $site->{'om_render_lang'} = "fra";

    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Red";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_pre'} = "15000-A";

    $FORM{'title_inp'} = "Rouge";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant'};
    $FORM{'status_inp'} = "15000-A";

    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    foreach $obj (@objids) {
	$object_hashref = {};
	$object_hashref = &load_object($obj,  "", "", $where_clause, $site, $dbh, 1);
	&printHashref($object_hashref);
	print "\n____________________ NEXT _______________________\n";
    }
}


sub test_product {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($brands) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    my ($v);

    $v = 0;
    print "Testing product\n\n";
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Product ";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
	
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Product ";
    $FORM{'sku_series_pre'} = $$brands[0];
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Product Title";
    $FORM{'brief_inp'} = "Product brief";
    $FORM{'descript_inp'} = "Product Description";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Product ";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'sku_series_pre'} = $$brands[0];
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brand FRA";
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}


sub test_master_product {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($variant_sets) = shift;
    my ($master) = shift;
    my ($brands) = shift;
    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    my ($v);

    $v = 0;
    print "Testing master product\n\n";
    %FORM = {};
    $FORM{'title_inp'} = "Auto Generated Master Product ";
    $FORM{'brief_inp'} = "Brief Hello";
    $FORM{'descript_inp'} = "Descript Hello";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'axisnames_inp'}  = $$variant_sets[$v];
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$$master[$i] = $FORM{'objid'};
	$objids[$i++] = $FORM{'objid'};
	
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Master Product ";
    $FORM{'sku_series_pre'} = $$brands[0];
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'axisnames_pre'}  = $$variant_sets[$v];
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Master Master Product Title";
    $FORM{'brief_inp'} = "Master Master Product brief";
    $FORM{'descript_inp'} = "Master Master Product Description";
    $FORM{'keywords_inp'} = "These are the keywords";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'axisnames_inp'}  = $$variant_sets[$v];
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "89";
    $FORM{'new_inp'} = "New Attribute";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Master Product ";
    $FORM{'brief_pre'} = "Brief Hello";
    $FORM{'descript_pre'} = "Descript Hello";
    $FORM{'keywords_pre'} = "These are the keywords";
    $FORM{'sku_series_pre'} = $$brands[0];
    $FORM{'axisnames_pre'}  = $$variant_sets[$v];
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'new_pre'} = "";

    $FORM{'title_inp'} = "Modified Brand FRA";
    $FORM{'sku_series_inp'} = $$brands[0];
    $FORM{'brief_inp'} = "Brief Hello FRA";
    $FORM{'descript_inp'} = "Modified Description FRA";
    $FORM{'keywords_inp'} = "These are the keywords FRA";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'axisnames_inp'}  = $$variant_sets[$v];
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}



sub test_modify_variant_titles {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($master_objid) = shift;
    my ($variants) = shift;
    my ($variant_sets) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    my ($v);
    print "Modifying master title to change variant title";
    $v = 0;

    %FORM = {};
    $FORM{'title_pre'} = "Auto Generated Master Product ";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'axisnames_pre'}  = $$variant_sets[$v];


    $FORM{'title_inp'} = "New Master!  Change variants!";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'axisnames_inp'}  = $$variant_sets[$v];
    $res = &update_object($master_objid,\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $master_objid\n";
    }
    else {
	print "Error: $res\n";
    }
    &printHashref($object_hashref);

    print "\n\n***********************************************\n\n";
    print "Modifying variant to change variant title";

    %FORM = {};
    $FORM{'title_pre'} = "Blue";
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'variant'};

    $FORM{'title_inp'} = "Dark Blue";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'variant'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'variant'};
    $res = &update_object($$variants[1],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $master_objid\n";
    }
    else {
	print "Error: $res\n";
    }
    &printHashref($object_hashref);

}



sub test_variant_product {
    my ($site) = shift;
    my ($dbh) = shift;
    my ($master_objid) = shift;
    my ($variants) = shift;

    my ($encoding, %FORM, $res, @objids, $i, $where_clause, $obj, $object_hashref);
    my ($v);

    $v = 0;
    print "Testing Variant Product \n\n";
    %FORM = {};
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15000-A";
    $FORM{'vcode_inp'} = "$$variants[0]:$$variants[1]";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "100";
    $FORM{'master_objid'} = $master_objid;

    $res = &create_object(\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Created object $FORM{'objid'}\n";
	$objids[$i++] = $FORM{'objid'};
	
    }
    else {
	print "Error: $res\n";
    }

    $i = 0;
    %FORM = {};
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'vcode_pre'} = "$$variants[0]:$$variants[1]";
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "100";
    $FORM{'master_objid'} = $master_objid;


    $FORM{'vcode_inp'} =  "$$variants[0]:$$variants[1]";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "50";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $site->{'om_render_lang'} = "fra";

    $i = 0;

    %FORM = {};
    $FORM{'objtype_pre'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_pre'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'vcode_pre'} = "$$variants[0]:$$variants[1]";
    $FORM{'status_pre'} = "15000-A";
    $FORM{'visibility_pre'} = "110000-A";    
    $FORM{'weight_man_pre'} = "89";
    $FORM{'master_objid'} = $master_objid;


    $FORM{'vcode_inp'} =  "$$variants[0]:$$variants[1]";
    $FORM{'objtype_inp'} = $site->{'OBJTYPES'}->{'product'};
    $FORM{'objclass_inp'} = $site->{'OBJCLASSES'}->{'product'};
    $FORM{'status_inp'} = "15001-A";
    $FORM{'visibility_inp'} = "110000-A";    
    $FORM{'weight_man_inp'} = "60";
    $FORM{'new_inp'} = "New Attribute FRA";
    $res = &update_object($objids[$i],\%FORM, $site, $dbh);
    if (!defined $res) {
	print "Updated object $objids[$i]\n";
    }
    else {
	print "Error: $res\n";
    }

    $where_clause = {};
    $object_hashref = {};
    $object_hashref = &load_object($objids[$i],  "", "", $where_clause, $site, $dbh, 1);
    &printHashref($object_hashref);
}

######################### INITIALIZATION SUBROUTINES #######################

##############################################################################
=pod

=head2 initscript

initscript - ($site, $dbh) = &initscript();

=over 4

=item DESCRIPTION

Determine the relative path, and connect to the database

=item INPUT

none

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

=back

=cut
###############################################################################
sub initscript {
    my ($s, @temp, @rpath, $rundir, $siteshortname, $u, $scriptname, $relpath);
    my ($k, $dbh, $site);
    
    ## determine path from store (site) root and store db name...
    #
    #  note - this script runs at server root or in cgi-bin/om/admin,
    #    generally. Test these conditions first.
    #  $0 - may not contain a full path, bootstrap with "pwd"
    #
    if ( $0 !~ /^\// ) {  # $0 is not an absolute path
        $s=`pwd`;          # hope pwd on path...
        chomp $s;
        $s.="/$0";
        } else {              # $0 IS an absolute path
        $s=$0;
    } # done determining if $0 is relative or absolute
    @temp=split /\//, $s;
    @rpath=@temp;
    
    $scriptname = pop @rpath;
    $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
    
    $rundir= join "/", @rpath;
    chdir( $rundir );
    
    $relpath="";
    $siteshortname="";

    ## short circuit if $s does not contain tests
    if ( $s !~ /tests/ ) {
	$siteshortname = pop @rpath;
	$relpath=".";
	@temp=();
    } # done testing for degenerate case
    
    while ( @temp ) {
        $u = pop @temp;
        
        ## skip references to the present directory
        next if ( $u eq '.' );
        next if ( length($u)==0 );        # skip null directory levels
        
        $relpath.="/.." if ( $relpath);
        $relpath.="." if ( ! $relpath );
        
	if ( $u eq "tests" ) {
	    $siteshortname = $temp[$#temp];
	    @temp=();
	} # note - tests is off the site root, so the next up is site root        
    } # done constructing relative path to store root
    
    $relpath .= "/../$siteshortname";
    ($site, $dbh) = &initsite($scriptname, $relpath);
    $site->{'siteshortname'} = $siteshortname;
    
    return ($site, $dbh);
}

##############################################################################
=pod

=head2 initsite

initsite - ($site, $dbh) = &initsite($scriptname, $relpath);

=over 4

=item DESCRIPTION

The init site loads in all required library modules and creates the variables 
that are required throughout the script. 

=item INPUT

$scriptname - The name of the script (inventory.cgi)

$relpath - The relative path to files that must be required

=item OUTPUT

$site - A hashref containing information required throughout about the current
        site and session

$dbh - current active database handle

=item NOTES

To add parameters that need to be passed around to a lot of locations, add them
to the $site hashref.

To change the debug of the script, change $site->{'debug_level'} to one of the 
following values:

    0 - no debug

    1 - errors only

    2 - all SQL statements, warnings & errors

    3 - all of the above

To change the location of the debug log, change the value of $site->{'debug_log'}. 
Be sure to start it will >> to allow appending to the file.  To set the Generate
Page? button to be selected by default, change the $site->{'generate_default'} to
1.  To have it non-selected by default, change the $site->{'generate_default'} 
to 0.

=back

=cut
###############################################################################
sub initsite {
    my ($scriptname) = shift;
    my ($relpath) = shift;
    
    my ($find, $q, $interface, $sts, $h, $x, @temp, $n, $k);
    my ($session_lang, $script, $site, $dbh);
    my ($select_hash, $q2);

    use DBI;
    require "$relpath/conf/site.pm";
    require "$relpath/lib/conversions.pm";
    require "$relpath/lib/filetools.pm";
    require "$relpath/lib/formtools.pm";
    require "$relpath/lib/variant.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/admin_object.pm";
    require "$relpath/lib/localization.pm";
    require "$relpath/lib/objects.pm";
    require "$relpath/lib/permission_layer.pm";    
    require "$relpath/lib/db_layer.pm";
    require "$relpath/lib/language.pm";
    require "$relpath/lib/validate.pm";
    require "$relpath/conf/html_def.pm";
    
    # must be the last require statement
    require "$relpath/lib/custom-lib.pm";
    
    ## establish site-specific parameters
    #
    $site=setsite();
    
    ## connect to database
    # system 6 database state, products, and customer tables are collapsed
    #
    $q = "$site->{'db_site_config'}";
    $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
    
    $site->{'om_render_lang'} = "";
    $site->{'om_render_lang'}=$site->{'om_locale_lang_def'} if ( ! $site->{'om_render_lang'} );
    $site->{'om_render_lang'}="eng" if ( ! $site->{'om_render_lang'} );
    $interface="html" if ( ! $interface );
    
    ## load messages
    $script=( split /\./, $scriptname )[0];

    # Configure all parameters to pass around in $site hash
    $site->{'selskeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/html/sel";
    $site->{'skeletonpath'} = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$site->{'om_render_lang'}/pages";
    $site->{'scriptpath'} = join "/", ( @temp[0..$n] );
    $site->{'script'} = ( split /\./, $scriptname )[0];
    $site->{'scriptname'} = $scriptname;
    $site->{'relpath'} = $relpath;
    $site->{'debug_level'} = 3;
    $site->{'debug_log'} = ">>/tmp/test_admin";
    $site->{'sid'} = $site->{'sid'};
    $site->{'session_lang'} = $session_lang;
    $site->{'scriptinfo'} = "$site->{'scriptpath'}/$site->{'scriptname'}";
    $site->{'targetpath'}="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/transit/export/order";    
    ($site->{'OBJCLASSES'}, $site->{'OBJTYPES'}) = &getClassesAndTypes();
    # Flag, set to 0 to have default for Generate page? as no, and
    # set to 1 to have default as yes
    $site->{'generate_default'} = 0;
    $site->{'languageSensitive'} = "title,brief,keywords,author,descript,encoding,uperms,uperm,gen_trigs";
    $site->{'inherit_from_master'} = "brief";
    $site->{'autosku'} = "yes";
    $site->{'override_permissions'} = "yes";

    &debug("Debuggin inventory.cgi...",3, $site->{'debug_level'}, ">/tmp/inventory");
    return ($site, $dbh);
}





